;________________________________________________________________________
;
;                                A X 2 5 . A S M
;________________________________________________________________________
;
; AX25 UI Packet Sending  by Byon Garrabrant  N6BG  byon@mail.com  Feb 99
;________________________________________________________________________
;
;   This software is  available only for non-commercial  amateur radio 
;   or educational  applications.   ALL  other  uses  are  prohibited.  
;   This  software may  be  modified  only  if the  resulting code  be 
;   made available  publicly  and the  original  author given  credit.  
;   Contact the author or TAPR for information on commercial licenses. 
;   (c) Copyright 1999,  Byon Garrabrant,  N6BG.  All rights reserved. 
;________________________________________________________________________

	cblock				; variables
		ax25_temp
		ax25_sending_char
		ax25_sending_count
		ax25_bit_history
		ax25_crc_hi
		ax25_crc_lo
	endc
;________________________________________________________________________

AX25_Send_Bit
	rlf	ax25_bit_history, F	; store the last 8 bits sent
	rrf	ax25_bit_history, W	; restore the bit

	call	Tone_Toggle_If_No_Carry

	comf	ax25_bit_history, W	; check the last 5 bits
	andlw	H'1F'
 	skpz				; if not all 1s
 	 return				; return

	clrc				; send a transparent 0 bit
	goto	AX25_Send_Bit			
;________________________________________________________________________

AX25_Send_Flag:
	movlw	H'7E'
	movwf	ax25_sending_char
	movlw	8
	movwf	ax25_sending_count
AX25_Send_Flag_Loop
	rrf	ax25_sending_char, F	; get bit for sending
 	call	AX25_Send_Bit
	clrf	ax25_bit_history	; no bit stuffing for flags
	decfsz	ax25_sending_count, F
	 goto	AX25_Send_Flag_Loop
	return 
;________________________________________________________________________

; Note: One these should be called just before AX25_Send_Start

AX25_Prep_Manual
	movlw	OPT_MANUAL_TX_DELAY		; send initial flags
	call	Get_Option
	movwf	ax25_temp
	return

AX25_Prep_Auto
	movlw	OPT_AUTO_TX_DELAY		; send initial flags
	call	Get_Option
	movwf	ax25_temp
	return

;________________________________________________________________________

AX25_Send_Start
	call	Tone_Enable		; start tone

AX25_Send_Start_Flag_Loop
	call	AX25_Send_Flag
	decfsz	ax25_temp, F
	 goto	AX25_Send_Start_Flag_Loop

	movlw	H'FF'			; crc inits to 0xFFFF
	movwf	ax25_crc_hi
	movwf	ax25_crc_lo
	return
;________________________________________________________________________

AX25_Send_Data
	movwf	ax25_sending_char
	movlw	8
	movwf	ax25_sending_count
AX25_Send_Data_Loop
	rrf	ax25_sending_char, W	; get bit for CRC

	movlw	1
	skpnc
	 xorwf	ax25_crc_lo, F		; crc ^= d & 1;

	clrc
	rrf	ax25_crc_hi, F
	rrf	ax25_crc_lo, F
	skpc
	 goto	AX25_CRC_Done
	movlw	H'08'
	xorwf	ax25_crc_lo, F
	movlw	H'84'
	xorwf	ax25_crc_hi, F		; crc = ( crc & 1 ) ? ( crc >> 1 ) ^ POLY : ( crc >> 1 );
AX25_CRC_Done

	rrf	ax25_sending_char, F	; get bit for sending
 	call	AX25_Send_Bit
	decfsz	ax25_sending_count, F
	 goto	AX25_Send_Data_Loop
	return 
;________________________________________________________________________

AX25_Send_End
	movlw	H'FF'			; send CRC
	xorwf	ax25_crc_lo, F		; invert lo
	xorwf	ax25_crc_hi, W		; invert hi and
	movwf	ax25_temp		; save in temp
	movfw	ax25_crc_lo		; send lo
	call	AX25_Send_Data
	movfw	ax25_temp		; send hi
	call	AX25_Send_Data

	call	AX25_Send_Flag		; send final flags
	call	AX25_Send_Flag		; send final flags

	call	Tone_Disable		; stop tone
	return
;________________________________________________________________________

